<script>
import trackUIControl from '../services/track_ui_control';
import ToolbarButton from './toolbar_button.vue';
import ToolbarImageButton from './toolbar_image_button.vue';
import ToolbarLinkButton from './toolbar_link_button.vue';
import ToolbarTableButton from './toolbar_table_button.vue';
import ToolbarTextStyleDropdown from './toolbar_text_style_dropdown.vue';
import ToolbarMoreDropdown from './toolbar_more_dropdown.vue';

export default {
  components: {
    ToolbarButton,
    ToolbarTextStyleDropdown,
    ToolbarLinkButton,
    ToolbarTableButton,
    ToolbarImageButton,
    ToolbarMoreDropdown,
  },
  methods: {
    trackToolbarControlExecution({ contentType, value }) {
      trackUIControl({ property: contentType, value });
    },
  },
};
</script>
<template>
  <div
    class="gl-display-flex gl-flex-wrap gl-pb-3 gl-pt-0 gl-border-b-solid gl-border-b-1 gl-border-b-gray-200"
  >
    <toolbar-text-style-dropdown
      data-testid="text-styles"
      class="gl-mr-3"
      @execute="trackToolbarControlExecution"
    />
    <toolbar-button
      data-testid="bold"
      content-type="bold"
      icon-name="bold"
      class="gl-mx-2"
      editor-command="toggleBold"
      :label="__('Bold text')"
      @execute="trackToolbarControlExecution"
    />
    <toolbar-button
      data-testid="italic"
      content-type="italic"
      icon-name="italic"
      class="gl-mx-2"
      editor-command="toggleItalic"
      :label="__('Italic text')"
      @execute="trackToolbarControlExecution"
    />
    <toolbar-button
      data-testid="strike"
      content-type="strike"
      icon-name="strikethrough"
      class="gl-mx-2"
      editor-command="toggleStrike"
      :label="__('Strikethrough')"
      @execute="trackToolbarControlExecution"
    />
    <toolbar-button
      data-testid="code"
      content-type="code"
      icon-name="code"
      class="gl-mx-2"
      editor-command="toggleCode"
      :label="__('Code')"
      @execute="trackToolbarControlExecution"
    />
    <toolbar-link-button data-testid="link" @execute="trackToolbarControlExecution" />
    <toolbar-image-button
      ref="imageButton"
      data-testid="image"
      @execute="trackToolbarControlExecution"
    />
    <toolbar-button
      data-testid="blockquote"
      content-type="blockquote"
      icon-name="quote"
      class="gl-mx-2"
      editor-command="toggleBlockquote"
      :label="__('Insert a quote')"
      @execute="trackToolbarControlExecution"
    />
    <toolbar-button
      data-testid="code-block"
      content-type="codeBlock"
      icon-name="doc-code"
      class="gl-mx-2"
      editor-command="toggleCodeBlock"
      :label="__('Insert a code block')"
      @execute="trackToolbarControlExecution"
    />
    <toolbar-button
      data-testid="bullet-list"
      content-type="bulletList"
      icon-name="list-bulleted"
      class="gl-mx-2"
      editor-command="toggleBulletList"
      :label="__('Add a bullet list')"
      @execute="trackToolbarControlExecution"
    />
    <toolbar-button
      data-testid="ordered-list"
      content-type="orderedList"
      icon-name="list-numbered"
      class="gl-mx-2"
      editor-command="toggleOrderedList"
      :label="__('Add a numbered list')"
      @execute="trackToolbarControlExecution"
    />
    <toolbar-button
      data-testid="details"
      content-type="details"
      icon-name="details-block"
      class="gl-mx-2"
      editor-command="toggleDetails"
      :label="__('Add a collapsible section')"
      @execute="trackToolbarControlExecution"
    />
    <toolbar-table-button data-testid="table" @execute="trackToolbarControlExecution" />
    <toolbar-more-dropdown data-testid="more" @execute="trackToolbarControlExecution" />
  </div>
</template>
<style>
.gl-spinner-container {
  text-align: left;
}
</style>
